#include <math.h>
#include <stdio.h>

#include "type.h"

double BinToDec(ChromType *gene, int size);

GlobalAppType app;

double Decode(ChromType *genes, GlobalAppType *a) 
{
  int i; 
  double sum, val, precision;

  sum = 0.0;
  val = BinToDec(genes, a->nBitsPerGene);

  precision = (a->upperStep - a->lowerStep)/(pow(2.0, a->nBitsPerGene) - 1);

  sum = a->lowerStep + (precision * val);

  return sum;
}

int main(int argc, char *argv[])
{
  int x, i, index;
  int bin[10];
  double y;
  GlobalAppType *a;

  a = &app;

  x = atoi (argv[1]);
  index = atoi (argv[2]);
  for(i = 0; i < x; i++){
    bin[i] = 1;
  }
  for(i = x; i < 10; i++){
    bin[i] = 0;
  }

  a->lowerStep = -0.3;
  a->upperStep = 0.4;
  a->nBitsPerGene = 3;

  y = Decode(&(bin[index]), a);

  printf("Decode %f\n", y);
}


double BinToDec(ChromType *gene, int size)
{
  int i;
  double sum;
  sum = 0.0;
  for(i = 0; i < size; i++){
    if(gene[i] == 1){
      sum += pow(2.0, (double) i);
    }
    printf("%1i", gene[i]); 
  }
  printf("\n");
  return sum;
}

